#include "cpcrslib.h"

extern const unsigned char sp_1[];	//masked sprite data
extern const unsigned char sp_2[];	//masked sprite data
extern const unsigned char blue[];
extern unsigned char buffer[];	//inks
const int screenWidth = 320;
const int meanLetterWidth = 8;

struct sprite  		// minimun sprite structure
{
    char *sp0;		//2 bytes 	01
    char *sp1;		//2 bytes	23
    int coord0;		//2 bytes	45	current superbuffer address
    int coord1;		//2 bytes	67  old superbuffer address
    unsigned char cx, cy;	//2 bytes 89 	current coordinates
    unsigned char ox, oy;	//2 bytes 1011  old coordinates
    unsigned char move1;	// los bits 4,3,2 definen el tipo de dibujo!!
    unsigned char move;		// 	in this example, to know the movement direction of the sprite
	unsigned char objetivoX, objetivoY;
};

struct sprite coloca_ladrones,guardia1,guardia2, sprite_Camera, ladron1, ladron2, ladron3, ladron4, desactivar_camaras, trofeo;

void data(void)
{

    __asm
_buffer:
    .db #30
	
_sp_1:
    .db #3,#11 //sprite dimensions in bytes width, height
    .db #0x01,#0x01,#0x0E,#0x0E,#0x00,#0x00
	.db #0x03,#0x03,#0x0F,#0x0F,#0x00,#0x00
	.db #0x07,#0x07,#0x2D,#0x2D,#0x08,#0x08
	.db #0x0F,#0x0F,#0x1E,#0x1E,#0x0C,#0x0C
	.db #0x0F,#0x0F,#0x0F,#0x0F,#0x0C,#0x0C
	.db #0x0F,#0x0F,#0x1E,#0x1E,#0x0C,#0x0C
	.db #0x0F,#0x0F,#0x07,#0x07,#0x0C,#0x0C
	.db #0x0F,#0x0F,#0x0B,#0x0B,#0x0C,#0x0C
	.db #0x07,#0x07,#0x0F,#0x0F,#0x08,#0x08
	.db #0x03,#0x03,#0x0F,#0x0F,#0x00,#0x00
	.db #0x00,#0x00,#0x0E,#0x0E,#0x00,#0x00
	
_blue:
	.db #2,#8
	.db #0x0F,#0x0F,#0x0F,#0x0F
	.db #0x0F,#0x0F,#0x0F,#0x0F
	.db #0x0F,#0x0F,#0x0F,#0x0F
	.db #0x0F,#0x0F,#0x0F,#0x0F
	.db #0x0F,#0x0F,#0x0F,#0x0F
	.db #0x0F,#0x0F,#0x0F,#0x0F
	.db #0x0F,#0x0F,#0x0F,#0x0F
	.db #0x0F,#0x0F,#0x0F,#0x0F

/*_sp_2:
	.db #3,#16 //sprite dimensions in bytes width, height
    .db #0x11,#0xFF,#0x00
	.db #0x33,#0xFF,#0xEE
	.db #0x03,#0x69,#0x80
	.db #0x25,#0xE1,#0xE0
	.db #0x25,#0x78,#0x78
	.db #0x16,#0xE1,#0x0E
	.db #0x10,#0xF0,#0xC0
	.db #0x03,#0x8F,#0x08
	.db #0x07,#0x9F,#0x0E
	.db #0x0F,#0xFF,#0x0F
	.db #0xD3,#0xF6,#0xBC
	.db #0xF1,#0xFF,#0xF8
	.db #0xF3,#0xFF,#0xFC
	.db #0x33,#0x99,#0xCC
	.db #0x07,#0x00,#0x0E
	.db #0x0F,#0x00,#0x0F */
    __endasm;
}

void *p_sprites[10];

void initPointers()
{
    p_sprites[0] = &coloca_ladrones;
    p_sprites[1] = &guardia1;
    p_sprites[2] = &guardia2;
	p_sprites[3] = &ladron1;
	p_sprites[4] = &ladron2;
	p_sprites[5] = &ladron3;
	p_sprites[6] = &ladron4;
	p_sprites[7] = &sprite_Camera;
	p_sprites[8] = &desactivar_camaras;
	p_sprites[9] = &trofeo;
}

void initSprites(){
	
	
}

void pause(void)
{
    __asm
    ld b,#80
pause_loop:
    halt
    djnz pause_loop
    __endasm;
}

int collide(void)
{
	cpc_ClrScr();
	cpc_PrintGphStrStdXY(1, "Fin del juego", (screenWidth-(14*meanLetterWidth))/2, 160);

	return 1;
}

void draw_tilemap(void)
{
    unsigned char x,y;
    //set the tiles of the map. In this example, the tile map is 32x16 tile
    //Tile Map configuration file: TileMapConf.asm

    y=0;
    for(x=0; x<20; x++)
    {
        cpc_SetTile(x,y,2);
    }
    for(y=1; y<10; y++)
    {
        for (x=0; x<20; x++)
        {
            cpc_SetTile(x,y,0);
        }
    }
    y=10;
    for (x=0; x<20; x++)
    {
        cpc_SetTile(x,y,2);
    }
}

void print_credits(void)
{
    cpc_PrintGphStrXY("SMALL;SPRITE;DEMO",9*2+3,20*8);
    cpc_PrintGphStrXY("SDCC;;;CPCRSLIB",10*2+3,21*8);
    cpc_PrintGphStrXY("BY;ARTABURU;2012",10*2+3-1,22*8);
    cpc_PrintGphStrXY("ESPSOFT<AMSTRAD<ES",10*2+3-3,24*8);
}

int colisionaConEnemigo(){
	if((cpc_CollSp(p_sprites[0],p_sprites[1])) || (cpc_CollSp(p_sprites[0],p_sprites[2]))){ return 1;}
	return 0;
}

void alertar_guardias(int ladron_detectado){
	int prueba = ladron_detectado;
	cpc_ClrScr();
	cpc_PrintGphStrXY("Detectado Ladron",9*2+3,20*8);
}

int ladron_en_desactivar_camara(){
	if((ladron3.cx == sprite_Camera.cx) && (ladron3.cy == sprite_Camera.cy)) return 1;
	
	return 0;
}
void camara_detecta(){
	if((ladron1.cx == sprite_Camera.cx) && (ladron1.cy > 50)) alertar_guardias(1);
	if((ladron2.cx == sprite_Camera.cx) && (ladron2.cy > 50)) alertar_guardias(2);
	if((ladron3.cx == sprite_Camera.cx) && (ladron3.cy > 50)) alertar_guardias(3);
	if((ladron4.cx == sprite_Camera.cx) && (ladron4.cy > 50)) alertar_guardias(4);
	
}



main()
{
    unsigned char a;
	int end_game = 0;
	int camaras_desactivadas = 0;
	int begin = 0;
	int num_ladrones = 0;

    initPointers();

	cpc_AssignKey(4,0x4804); //ESC
    //set_colours();
    //cpc_SetInkGphStr(0,0);
    cpc_SetModo(1);

    cpc_DisableFirmware();
    // All the sprite values are initilized
	//Sprite para colocar los ladrones
   
	
	coloca_ladrones.sp1=blue;
    coloca_ladrones.sp0=blue;
    coloca_ladrones.ox=50;
    coloca_ladrones.oy=70;
    coloca_ladrones.cx=50;
    coloca_ladrones.cy=70;
    coloca_ladrones.move1=3;
    cpc_SuperbufferAddress(p_sprites[0]); //first time it's important to do this

	//Sprites de guardias
    guardia1.sp1=sp_1;
    guardia1.sp0=sp_1;
    guardia1.ox=50;
    guardia1.oy=106;
    guardia1.cx=50;
    guardia1.cy=106;
    guardia1.move=1;
    guardia1.move1=3;
    cpc_SuperbufferAddress(p_sprites[1]);

    guardia2.sp1=sp_1;
    guardia2.sp0=sp_1;
    guardia2.ox=20;
    guardia2.oy=100;
    guardia2.cx=20;
    guardia2.cy=100;
    guardia2.move=2;
    guardia2.move1=3;
    cpc_SuperbufferAddress(p_sprites[2]);
	
	//Sprite de ladrones
	ladron1.sp1=blue;
    ladron1.sp0=blue;
    ladron1.ox=3;
    ladron1.oy=5;
    ladron1.cx=3;
    ladron1.cy=5;
    ladron1.move=2;
    ladron1.move1=3;
    cpc_SuperbufferAddress(p_sprites[3]);
	
	ladron2.sp1=blue;
    ladron2.sp0=blue;
    ladron2.ox=3;
    ladron2.oy=15;
    ladron2.cx=3;
    ladron2.cy=15;
    ladron2.move=2;
    ladron2.move1=3;
    cpc_SuperbufferAddress(p_sprites[4]);
	
	ladron3.sp1=blue;
    ladron3.sp0=blue;
    ladron3.ox=3;
    ladron3.oy=25;
    ladron3.cx=3;
    ladron3.cy=25;
    ladron3.move=2;
    ladron3.move1=3;
    cpc_SuperbufferAddress(p_sprites[5]);
	
	ladron4.sp1=blue;
    ladron4.sp0=blue;
    ladron4.ox=3;
    ladron4.oy=35;
    ladron4.cx=3;
    ladron4.cy=35;
    ladron4.move=2;
    ladron4.move1=3;
    cpc_SuperbufferAddress(p_sprites[6]);
	
	//Sprite de la camara
	sprite_Camera.sp1 = sp_1;
	sprite_Camera.sp0 = sp_1;
    sprite_Camera.ox=30;
    sprite_Camera.oy=50;
    sprite_Camera.cx=30;
    sprite_Camera.cy=50;
    sprite_Camera.move1=3;
    cpc_SuperbufferAddress(p_sprites[7]); //first time it's important to do this
	
	
	desactivar_camaras.sp1 = blue;
	desactivar_camaras.sp0 = blue;
    desactivar_camaras.ox=20;
    desactivar_camaras.oy=30;
    desactivar_camaras.cx=20;
    desactivar_camaras.cy=30;
    desactivar_camaras.move1=3;
    cpc_SuperbufferAddress(p_sprites[8]); //first time it's important to do this
	
	
	//trofeo
	trofeo.sp1 = sp_1;
	trofeo.sp0 = sp_1;
    trofeo.ox=90;
    trofeo.oy=90;
    trofeo.cx=90;
    trofeo.cy=90;
    trofeo.move1=3;
    cpc_SuperbufferAddress(p_sprites[9]); //first time it's important to do this
	
	
    //Drawing the tile map
    draw_tilemap();
    cpc_ShowTileMap();		//Show entire tile map in the screen
   // print_credits();
    cpc_SetTile(0,1,2);
	
    /*cpc_GetTiles(0,0,2,3, buffer);

    cpc_PutTiles(0,13,2,3, buffer);
    cpc_GetTiles(0,13,2,3, buffer);
    cpc_PutTiles(8,9,2,3, buffer); */

    cpc_ShowTileMap();		//Show entire tile map in the screen
	while(begin == 0){
		if (cpc_TestKey(0)==1 && coloca_ladrones.cx<60) coloca_ladrones.cx++;
        if (cpc_TestKey(1)==1 && coloca_ladrones.cx>0) coloca_ladrones.cx--;
        if (cpc_TestKey(2)==1 && coloca_ladrones.cy>0) coloca_ladrones.cy-=2;
        if (cpc_TestKey(3)==1 && coloca_ladrones.cy<112) coloca_ladrones.cy+=2;
		
		cpc_ResetTouchedTiles();		//clear touched tile table

		if(cpc_TestKey(4) == 1){
			pause();
			if(num_ladrones == 0){
				ladron1.objetivoX = coloca_ladrones.cx;
				ladron1.objetivoY = coloca_ladrones.cy;
			}else if(num_ladrones == 1){
				ladron2.objetivoX = coloca_ladrones.cx;
				ladron2.objetivoY = coloca_ladrones.cy;
			}else if(num_ladrones == 2){
				ladron3.objetivoX = coloca_ladrones.cx;
				ladron3.objetivoY = coloca_ladrones.cy;
			}else if(num_ladrones == 3){
				ladron3.objetivoX = coloca_ladrones.cx;
				ladron3.objetivoY = coloca_ladrones.cy;
			}
			num_ladrones+=1;
		}
		

        //Sprite phase 1
					
        cpc_PutSpTileMap(p_sprites[0]);		//search the tiles where is and was the sprite
        cpc_PutSpTileMap(p_sprites[1]);
        cpc_PutSpTileMap(p_sprites[2]);
		cpc_PutSpTileMap(p_sprites[3]);
		cpc_PutSpTileMap(p_sprites[4]);
		cpc_PutSpTileMap(p_sprites[5]);
		cpc_PutSpTileMap(p_sprites[6]);
		cpc_PutSpTileMap(p_sprites[7]);
		cpc_PutSpTileMap(p_sprites[8]);
		cpc_PutSpTileMap(p_sprites[9]);
		 //cpc_PutSpTileMap(p_sprites[3]);



        cpc_UpdScr(); 					//Update the screen to new situatio (show the touched tiles)

        //Sprite phase 2
        cpc_PutMaskSpTileMap2b(p_sprites[0]);	//Requires to move sprite with cpc_SpUpdX or cpc_SpUpdY
        cpc_PutMaskSpTileMap2b(p_sprites[1]);
        cpc_PutMaskSpTileMap2b(p_sprites[2]);
		cpc_PutMaskSpTileMap2b(p_sprites[3]);
        cpc_PutMaskSpTileMap2b(p_sprites[4]);
		cpc_PutMaskSpTileMap2b(p_sprites[5]);
        cpc_PutMaskSpTileMap2b(p_sprites[6]);
		cpc_PutMaskSpTileMap2b(p_sprites[7]);
		cpc_PutMaskSpTileMap2b(p_sprites[8]);
		cpc_PutMaskSpTileMap2b(p_sprites[9]);
		// cpc_PutMaskSpTileMap2b(p_sprites[3]);

        cpc_ShowTileMap2();			//Show the touched tiles-> show the new sprite situatuion

	
		if(num_ladrones == 4) begin = 1;
	}
    while(end_game == 0)
    {
        //Default number keys for moving one of the sprites:
        // 0: cursor right
        // 1: cursor left
        // 2: cursor up
        // 3: cursor down

        //for example., if key 0 is pressed, and the sprite is inside tilemap, then
        //the sprite is moved one byte to the right:
		
        /*if (cpc_TestKey(0)==1 && coloca_ladrones.cx<60) coloca_ladrones.cx++;
        if (cpc_TestKey(1)==1 && coloca_ladrones.cx>0) coloca_ladrones.cx--;
        if (cpc_TestKey(2)==1 && coloca_ladrones.cy>0) coloca_ladrones.cy-=2;
        if (cpc_TestKey(3)==1 && coloca_ladrones.cy<112) coloca_ladrones.cy+=2;*/
		
		//movimiento de los ladrones
		
		

        //movimiento de los guardias
        if (guardia1.move==0)   //0 = left, 1 = right
        {
            if (guardia1.cx>0) guardia1.cx--;
            else guardia1.move=1;
        }
        if (guardia1.move==1)   //0 = left, 1 = right
        {
            if (guardia1.cx<60) guardia1.cx++;
            else guardia1.move=0;
        }

        if (guardia2.move==2)   //2 = up, 3 = down
        {
            if (guardia2.cy>0) guardia2.cy-=2;
            else guardia2.move=3;
        }
        if (guardia2.move==3)    //2 = up, 3 = down
        {
            if (guardia2.cy<106) guardia2.cy+=2;
            else guardia2.move=2;
        }


        cpc_ResetTouchedTiles();		//clear touched tile table



        //Sprite phase 1
							//search the tiles where is and was the sprite
        cpc_PutSpTileMap(p_sprites[1]);
        cpc_PutSpTileMap(p_sprites[2]);
		cpc_PutSpTileMap(p_sprites[3]);
		cpc_PutSpTileMap(p_sprites[4]);
		cpc_PutSpTileMap(p_sprites[5]);
		cpc_PutSpTileMap(p_sprites[6]);
		cpc_PutSpTileMap(p_sprites[7]);
		cpc_PutSpTileMap(p_sprites[8]);
		cpc_PutSpTileMap(p_sprites[9]);
		 //cpc_PutSpTileMap(p_sprites[3]);



        cpc_UpdScr(); 					//Update the screen to new situatio (show the touched tiles)

        //Sprite phase 2
	//Requires to move sprite with cpc_SpUpdX or cpc_SpUpdY
        cpc_PutMaskSpTileMap2b(p_sprites[1]);
        cpc_PutMaskSpTileMap2b(p_sprites[2]);
		cpc_PutMaskSpTileMap2b(p_sprites[3]);
        cpc_PutMaskSpTileMap2b(p_sprites[4]);
		cpc_PutMaskSpTileMap2b(p_sprites[5]);
        cpc_PutMaskSpTileMap2b(p_sprites[6]);
		cpc_PutMaskSpTileMap2b(p_sprites[7]);
		cpc_PutMaskSpTileMap2b(p_sprites[8]);
		cpc_PutMaskSpTileMap2b(p_sprites[9]);
		// cpc_PutMaskSpTileMap2b(p_sprites[3]);

        cpc_ShowTileMap2();			//Show the touched tiles-> show the new sprite situatuion


		if(colisionaConEnemigo() == 1) collide();
		if(camaras_desactivadas == 0){
			camara_detecta();
			camaras_desactivadas = ladron_en_desactivar_camara();	
		}
		
    }
}

