#ifndef SPRITE_H_
#define SPRITE_H_

//Estos son los sprites que se pintarán en el tilemap
extern const unsigned char police[];
extern const unsigned char flash[];
extern const unsigned char hulk[];
extern const unsigned char technic[];
extern const unsigned char chameleon[];
extern const unsigned char selected_tile[];

//Estos son los que se pintan en modo XOR
extern const unsigned char cursor_character[];
extern const unsigned char cursor_text[];
extern const unsigned char reset_off[];
extern const unsigned char reset_on[];
extern const unsigned char start_off[];
extern const unsigned char start_on[];
extern const unsigned char portrait_flash[];
extern const unsigned char portrait_hulk[];
extern const unsigned char portrait_technic[];
extern const unsigned char portrait_chameleon[];
extern const unsigned char logo[];

extern unsigned char buffer[];

struct sprite  		// minimun sprite structure
{
    char *sp0;		//2 bytes 	01
    char *sp1;		//2 bytes	23
    int coord0;		//2 bytes	45	current superbuffer address
    int coord1;		//2 bytes	67  old superbuffer address
    unsigned char cx, cy;	//2 bytes 89 	current coordinates
    unsigned char ox, oy;	//2 bytes 1011  old coordinates
    unsigned char move1;	// los bits 4,3,2 definen el tipo de dibujo!!
    unsigned char move;		// 	in this example, to know the movement direction of the sprite
	unsigned char objetivoX, objetivoY;
	unsigned char canMove;
	unsigned char vida;
	unsigned char ladron_id;
};

struct objeto
{
	unsigned char cx,cy;
	unsigned char activada;
	unsigned char orientacion;
};

struct objeto trofeo;
struct objeto camaras[3];
int num_camaras;

struct sprite coloca_ladrones, ladron_flash, ladron_hulk, ladron_technic, ladron_chameleon;
struct sprite polis[4];
int num_polis;

void *p_sprites[15];

void initPointers()
{
    p_sprites[0] = &coloca_ladrones;
    p_sprites[1] = &ladron_flash;
    p_sprites[2] = &ladron_hulk;
	p_sprites[3] = &ladron_technic;
	p_sprites[4] = &ladron_chameleon;
}

#endif /* SPRITE_H_ */